--[[
Script to allow objectChanges for the crop sensor configuration

Author:		Ifko[nator]
Date:		18.03.2024
Version:	1.0

History:	V1.0 @18.03.2024 - initial implementation in FS 22
]]


CropSensorConfigurationFix = {};

CropSensorConfigurationFix.precisionFarmingModTable = "";

function CropSensorConfigurationFix.prerequisitesPresent(specializations)
	return true;
end;

function CropSensorConfigurationFix:addObjectChanges()
	for _, mod in pairs(g_modManager.mods) do
		if mod.title == "Precision Farming DLC" then		
			if g_modIsLoaded[mod.modName] then	
				CropSensorConfigurationFix.precisionFarmingModTable = _G[mod.modName];

				ObjectChangeUtil.registerObjectChangeXMLPaths(Vehicle.xmlSchema, "vehicle.cropSensor.cropSensorConfigurations.cropSensorConfiguration(?)");

				break;
			end;
		end;
	end;

	if CropSensorConfigurationFix.precisionFarmingModTable ~= "" then
		function CropSensorConfigurationFix:onLoadFix(savegame)
			if self.configurations.cropSensor ~= nil then
				ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.cropSensor.cropSensorConfigurations.cropSensorConfiguration", self.configurations.cropSensor, self.components, self);
			end;
		end;
	
		CropSensorConfigurationFix.precisionFarmingModTable.CropSensor.onLoad = Utils.appendedFunction(CropSensorConfigurationFix.precisionFarmingModTable.CropSensor.onLoad, CropSensorConfigurationFix.onLoadFix);
	end;
end;

Vehicle.init = Utils.appendedFunction(Vehicle.init, CropSensorConfigurationFix.addObjectChanges);